Index: /data/trunk/worlds/single_player_proto_world_01.map
===================================================================
--- /data/trunk/worlds/single_player_proto_world_01.map	(revision 3813)
+++ /data/trunk/worlds/single_player_proto_world_01.map	(revision 3814)
@@ -327,4 +327,189 @@
 ( 448 -72 -24 ) ( 448 128 -24 ) ( 448 -72 64 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
 }
+// brush 36
+{
+( 520 784 -24 ) ( 520 720 -24 ) ( 448 784 -24 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( 520 840 64 ) ( 448 840 64 ) ( 520 840 -64 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( 784 760 64 ) ( 784 760 -64 ) ( 784 696 64 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( 448 712 -32 ) ( 520 712 -32 ) ( 448 776 -32 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( 448 712 -64 ) ( 448 712 64 ) ( 520 712 -64 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -168 712 -64 ) ( -168 776 -64 ) ( -168 712 64 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+}
+// brush 37
+{
+( 816 1040 -24 ) ( 816 968 -24 ) ( 736 1040 -24 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( 816 1048 -24 ) ( 736 1048 -24 ) ( 816 1048 -32 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( 816 1032 -24 ) ( 816 1032 -32 ) ( 816 960 -24 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( 736 968 -32 ) ( 816 968 -32 ) ( 736 1040 -32 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( 736 976 -32 ) ( 736 976 -24 ) ( 816 976 -32 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( 736 968 -32 ) ( 736 1040 -32 ) ( 736 968 -24 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+}
+// brush 38
+{
+( 864 776 -24 ) ( 864 704 -24 ) ( 784 776 -24 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( 864 840 -24 ) ( 784 840 -24 ) ( 864 840 -32 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( 920 776 -24 ) ( 920 776 -32 ) ( 920 704 -24 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( 784 704 -32 ) ( 864 704 -32 ) ( 784 776 -32 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( 792 328 -32 ) ( 792 328 -24 ) ( 872 328 -32 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( 784 704 -32 ) ( 784 776 -32 ) ( 784 704 -24 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+}
+// brush 39
+{
+( 752 720 64 ) ( 752 712 64 ) ( 528 720 64 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( 744 720 -24 ) ( 520 720 -24 ) ( 744 720 -32 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( 792 720 -24 ) ( 792 720 -32 ) ( 792 712 -24 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( 520 712 -32 ) ( 744 712 -32 ) ( 520 720 -32 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( 520 712 -32 ) ( 520 712 -24 ) ( 744 712 -32 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( 520 712 -32 ) ( 520 720 -32 ) ( 520 712 -24 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+}
+// brush 40
+{
+( 792 712 64 ) ( 792 568 64 ) ( 784 712 64 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( 792 712 64 ) ( 784 712 64 ) ( 792 712 -32 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( 792 424 64 ) ( 792 424 -32 ) ( 792 280 64 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( 784 568 -32 ) ( 792 568 -32 ) ( 784 712 -32 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( 784 328 -32 ) ( 784 328 64 ) ( 792 328 -32 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( 784 568 -32 ) ( 784 712 -32 ) ( 784 568 64 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+}
+// brush 41
+{
+( 920 624 64 ) ( 920 328 64 ) ( 912 624 64 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( 928 832 64 ) ( 920 832 64 ) ( 928 832 -32 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( 920 640 64 ) ( 920 640 -32 ) ( 920 344 64 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( 912 328 -32 ) ( 920 328 -32 ) ( 912 624 -32 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( 912 328 -32 ) ( 912 328 64 ) ( 920 328 -32 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( 912 328 -32 ) ( 912 624 -32 ) ( 912 328 64 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+}
+// brush 42
+{
+( 856 840 64 ) ( 856 832 64 ) ( 800 840 64 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( 856 840 64 ) ( 800 840 64 ) ( 856 840 -32 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( 920 840 64 ) ( 920 840 -32 ) ( 920 832 64 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( 800 832 -24 ) ( 856 832 -24 ) ( 800 840 -24 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( 856 832 -32 ) ( 856 832 64 ) ( 912 832 -32 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( -312 816 -32 ) ( -312 824 -32 ) ( -312 816 64 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+}
+// brush 43
+{
+( 456 720 64 ) ( 456 712 64 ) ( 344 720 64 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( 456 720 64 ) ( 344 720 64 ) ( 456 720 -32 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( 456 720 64 ) ( 456 720 -32 ) ( 456 712 64 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( 344 712 -32 ) ( 456 712 -32 ) ( 344 720 -32 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( 112 712 -32 ) ( 112 712 64 ) ( 224 712 -32 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( -168 696 -32 ) ( -168 704 -32 ) ( -168 696 64 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+}
+// brush 44
+{
+( -160 840 -24 ) ( -160 624 -24 ) ( -424 840 -24 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -168 840 56 ) ( -432 840 56 ) ( -168 840 -32 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -168 840 56 ) ( -168 840 -32 ) ( -168 624 56 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -432 624 -32 ) ( -168 624 -32 ) ( -432 840 -32 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -432 504 -32 ) ( -432 504 56 ) ( -168 504 -32 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -512 624 -32 ) ( -512 840 -32 ) ( -512 624 56 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+}
+// brush 45
+{
+( -312 840 64 ) ( -312 832 64 ) ( -512 840 64 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( -312 840 64 ) ( -512 840 64 ) ( -312 840 -24 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( -312 840 64 ) ( -312 840 -24 ) ( -312 832 64 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( -512 832 -24 ) ( -312 832 -24 ) ( -512 840 -24 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( -432 728 -24 ) ( -432 728 64 ) ( -312 832 64 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( -432 728 64 ) ( -432 728 -24 ) ( -432 840 -24 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+}
+// brush 46
+{
+( -168 720 64 ) ( -168 712 64 ) ( -328 720 64 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( -272 632 64 ) ( -272 632 -24 ) ( -168 720 -24 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( -168 720 64 ) ( -168 720 -24 ) ( -168 712 64 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( -328 712 -24 ) ( -168 712 -24 ) ( -328 720 -24 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( -272 624 -24 ) ( -272 624 64 ) ( -168 712 64 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( -272 624 -24 ) ( -272 632 -24 ) ( -272 624 64 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+}
+// brush 47
+{
+( -264 624 64 ) ( -264 512 64 ) ( -272 624 64 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( -264 624 64 ) ( -272 624 64 ) ( -264 624 -24 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( -264 624 64 ) ( -264 624 -24 ) ( -264 512 64 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( -272 512 -24 ) ( -264 512 -24 ) ( -272 624 -24 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( -272 504 -24 ) ( -272 504 64 ) ( -264 504 -24 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( -272 512 -24 ) ( -272 624 -24 ) ( -272 512 64 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+}
+// brush 48
+{
+( -272 512 64 ) ( -272 504 64 ) ( -472 512 64 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( -272 512 -16 ) ( -472 512 -16 ) ( -272 512 -24 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( -272 512 -16 ) ( -272 512 -24 ) ( -272 504 -16 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( -472 504 -24 ) ( -272 504 -24 ) ( -472 512 -24 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( -472 504 -24 ) ( -472 504 -16 ) ( -272 504 -24 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( -736 504 -24 ) ( -736 512 -24 ) ( -736 504 -16 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+}
+// brush 49
+{
+( -512 712 -24 ) ( -512 504 -24 ) ( -576 712 -24 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -512 736 -24 ) ( -576 736 -24 ) ( -512 736 -32 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -512 712 -24 ) ( -512 712 -32 ) ( -512 504 -24 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -576 504 -32 ) ( -512 504 -32 ) ( -576 712 -32 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -632 648 0 ) ( -632 648 8 ) ( -568 648 0 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -816 512 -32 ) ( -816 720 -32 ) ( -816 512 -24 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+}
+// brush 50
+{
+( -432 736 64 ) ( -432 728 64 ) ( -696 736 64 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( -432 736 64 ) ( -696 736 64 ) ( -432 736 -24 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( -432 736 64 ) ( -432 736 -24 ) ( -432 728 64 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( -696 728 -24 ) ( -432 728 -24 ) ( -696 736 -24 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( -696 728 -24 ) ( -696 728 64 ) ( -432 728 -24 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+( -968 728 -24 ) ( -968 736 -24 ) ( -968 728 64 ) gothic_floor/blocks17floor3 0 0 0 0.5 0.5 0 0 0
+}
+// brush 51
+{
+( -512 568 -24 ) ( -512 360 -24 ) ( -576 568 -24 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -368 592 -24 ) ( -432 592 -24 ) ( -368 592 -32 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -512 568 -24 ) ( -512 568 -32 ) ( -512 360 -24 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -576 360 -32 ) ( -512 360 -32 ) ( -576 568 -32 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -640 504 0 ) ( -640 504 8 ) ( -576 504 0 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -816 368 -32 ) ( -816 576 -32 ) ( -816 368 -24 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+}
+// brush 52
+{
+( -512 616 -24 ) ( -512 592 -24 ) ( -576 616 -24 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -512 616 -24 ) ( -512 616 -32 ) ( -512 592 -24 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -576 592 -32 ) ( -512 592 -32 ) ( -576 616 -32 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -576 592 -32 ) ( -576 592 -24 ) ( -512 592 -32 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -544 592 -64 ) ( -512 616 -64 ) ( -544 592 64 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+}
+// brush 53
+{
+( -512 648 -24 ) ( -512 624 -24 ) ( -576 648 -24 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -512 648 -24 ) ( -576 648 -24 ) ( -512 648 -32 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -512 648 -24 ) ( -512 648 -32 ) ( -512 624 -24 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -576 624 -32 ) ( -512 624 -32 ) ( -576 648 -32 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -512 624 -64 ) ( -544 648 -64 ) ( -512 624 64 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+}
+// brush 54
+{
+( -816 736 -24 ) ( -816 520 -24 ) ( -960 736 -24 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -816 736 -24 ) ( -960 736 -24 ) ( -816 736 -32 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -816 736 -24 ) ( -816 736 -32 ) ( -816 520 -24 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -960 520 -32 ) ( -816 520 -32 ) ( -960 736 -32 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -960 504 -32 ) ( -960 504 -24 ) ( -816 504 -32 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -960 520 -32 ) ( -960 736 -32 ) ( -960 520 -24 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+}
+// brush 55
+{
+( -816 624 -24 ) ( -816 648 -24 ) ( -752 624 -24 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -816 624 -24 ) ( -816 624 -32 ) ( -816 648 -24 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -752 648 -32 ) ( -816 648 -32 ) ( -752 624 -32 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -752 648 -32 ) ( -752 648 -24 ) ( -816 648 -32 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -784 648 -64 ) ( -816 624 -64 ) ( -784 648 64 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+}
+// brush 56
+{
+( -816 592 -24 ) ( -816 616 -24 ) ( -752 592 -24 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -816 592 -24 ) ( -752 592 -24 ) ( -816 592 -32 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -816 592 -24 ) ( -816 592 -32 ) ( -816 616 -24 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -752 616 -32 ) ( -816 616 -32 ) ( -752 592 -32 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+( -816 616 -64 ) ( -784 592 -64 ) ( -816 616 64 ) gothic_floor/metalbridge02b 0 0 0 0.5 0.5 0 0 0
+}
 }
 // entity 1