Index: /orxonox/trunk/src/animation.cc
===================================================================
--- /orxonox/trunk/src/animation.cc	(revision 3832)
+++ /orxonox/trunk/src/animation.cc	(revision 3833)
@@ -25,4 +25,5 @@
   this->bHasKeys = false;
   this->bHandled = true;
+  this->baseObject = NULL;
 
   // setting default values
@@ -55,4 +56,6 @@
   this->bRunning = true;
 }
+
+
 void Anim::stop()
 {
Index: /orxonox/trunk/src/animation.h
===================================================================
--- /orxonox/trunk/src/animation.h	(revision 3832)
+++ /orxonox/trunk/src/animation.h	(revision 3833)
@@ -28,4 +28,6 @@
 
 #include "list.h"
+#include "base_object.h"
+
 // FORWARD DEFINITION
 
@@ -52,25 +54,4 @@
   ANIM_FUNCTION animFunc;
 };
-
-
-/**********************TEST*******************************/
-class aTest
-{
- public:
-  aTest() { last = 0.0;}
-  ~aTest() {}
-  void littleDebug(float f) {  diff = f - last; printf("f=%f, diff=%f\n", f,diff); last = f;}
- private:
-  float diff;
-  float last;
-};
-
-//aTest::aTest() {}
-//aTest::~aTest() {}
-
-//void aTest::littleDebug(float f)
-
-/**********************TEST*******************************/
-
 
 class Anim
@@ -99,4 +80,10 @@
    * virtual rewind, to go to the first Keyframe. (other functions will call this one)
    */
+
+  /**
+     \returns the BaseObject, this animation operates on
+  */
+  BaseObject* getBaseObject(void) const { return baseObject;}
+
  protected:
   Anim(void);
@@ -107,4 +94,5 @@
   ANIM_INFINITY postInfinity;
 
+  BaseObject* baseObject;         //!< The same as object in the derived classes, but with reference to BaseObject
   bool bHasKeys;
   bool bHandled;                  //!< If this Animation is handled by the AnimationPlayer.
@@ -209,5 +197,5 @@
 void tAnim<T>::setFuncToAnim(T* object, void (T::*funcToAnim)(float))
 {
-  this->object = object;
+  this->baseObject = this->object = object;
   this->funcToAnim = funcToAnim;
 }
@@ -380,3 +368,24 @@
 
 
+
+/**********************TEST*******************************/
+class aTest
+{
+ public:
+  aTest() { last = 0.0;}
+  ~aTest() {}
+  void littleDebug(float f) {  diff = f - last; printf("f=%f, diff=%f\n", f,diff); last = f;}
+ private:
+  float diff;
+  float last;
+};
+
+//aTest::aTest() {}
+//aTest::~aTest() {}
+
+//void aTest::littleDebug(float f)
+
+/**********************TEST*******************************/
+
+
 #endif /* _ANIMATION_H */
Index: /orxonox/trunk/src/animation_player.cc
===================================================================
--- /orxonox/trunk/src/animation_player.cc	(revision 3832)
+++ /orxonox/trunk/src/animation_player.cc	(revision 3833)
@@ -142,4 +142,22 @@
 
 
+Anim* AnimationPlayer::getObjectFromBaseObject(const BaseObject* baseObject) const
+{
+  tIterator<Anim>* animIt = this->animationList->getIterator();
+  Anim* anim = animIt->nextElement();
+  while( anim != NULL)
+    {
+      if(anim->getBaseObject() == baseObject)
+	{
+	  delete animIt;
+	  return anim;
+	}
+      anim = animIt->nextElement();
+    }
+  delete animIt;
+
+}
+
+
 
 /**
Index: /orxonox/trunk/src/animation_player.h
===================================================================
--- /orxonox/trunk/src/animation_player.h	(revision 3832)
+++ /orxonox/trunk/src/animation_player.h	(revision 3833)
@@ -42,4 +42,6 @@
   void pause(void);
 
+  Anim* getObjectFromBaseObject(const BaseObject* baseObject) const;
+
   void debug(void);
 
Index: /orxonox/trunk/src/lib/graphics/text_engine.cc
===================================================================
--- /orxonox/trunk/src/lib/graphics/text_engine.cc	(revision 3832)
+++ /orxonox/trunk/src/lib/graphics/text_engine.cc	(revision 3833)
@@ -51,4 +51,6 @@
 Text::Text(Font* font, int type)
 {
+  this->setClassName("Text");
+
   // initialize this Text
   this->bindNode = NULL;
Index: /orxonox/trunk/src/lib/graphics/text_engine.h
===================================================================
--- /orxonox/trunk/src/lib/graphics/text_engine.h	(revision 3832)
+++ /orxonox/trunk/src/lib/graphics/text_engine.h	(revision 3833)
@@ -90,5 +90,5 @@
 ////////////
 //! Represents one textElement.
-class Text
+class Text : public BaseObject
 {
   friend class TextEngine;