Index: /orxonox/trunk/src/animation.cc
===================================================================
--- /orxonox/trunk/src/animation.cc	(revision 3846)
+++ /orxonox/trunk/src/animation.cc	(revision 3847)
@@ -20,5 +20,5 @@
 
 
-Anim::Anim(void)
+Animation::Animation(void)
 {  
   // initialize a beginning KeyFrame, that will be deleted afterwards
@@ -34,10 +34,10 @@
 }
 
-Anim::~Anim(void)
+Animation::~Animation(void)
 {
   this->doNotHandle();
 }
 
-void Anim::doNotHandle(void)
+void Animation::doNotHandle(void)
 {
   if (this->bHandled)
@@ -46,5 +46,5 @@
 
 
-void Anim::setInfinity(ANIM_INFINITY postInfinity)
+void Animation::setInfinity(ANIM_INFINITY postInfinity)
 {
   this->postInfinity = postInfinity;
@@ -52,5 +52,5 @@
 
 
-void Anim::play()
+void Animation::play()
 {
   this->bRunning = true;
@@ -58,5 +58,5 @@
 
 
-void Anim::stop()
+void Animation::stop()
 {
   this->rewind();
@@ -65,9 +65,9 @@
   this->bRunning = false;
 }
-void Anim::pause()
+void Animation::pause()
 {
   this->bRunning = false;
 }
-void Anim::replay()
+void Animation::replay()
 {
   this->rewind();
Index: /orxonox/trunk/src/animation.h
===================================================================
--- /orxonox/trunk/src/animation.h	(revision 3846)
+++ /orxonox/trunk/src/animation.h	(revision 3847)
@@ -55,8 +55,8 @@
 };
 
-class Anim
+class Animation
 {
  public:
-  virtual ~Anim(void);
+  virtual ~Animation(void);
   void doNotHandle(void);
 
@@ -87,5 +87,5 @@
 
  protected:
-  Anim(void);
+  Animation(void);
 
   // variables
@@ -102,9 +102,9 @@
 
 //! A Class to handle some animation for single floated values.
-template<class T> class tAnim : public Anim
+template<class T> class tAnimation : public Animation
 {
  public:
-  tAnim(T* object = NULL, void (T::*funcToAnim)(float) = NULL);
-  virtual ~tAnim();
+  tAnimation(T* object = NULL, void (T::*funcToAnim)(float) = NULL);
+  virtual ~tAnimation();
 
   virtual void rewind();
@@ -127,5 +127,5 @@
   float random(float timePassed) const;
   //  ANIM_FUNCTION animFunc;
-  float (tAnim<T>::*animFunc)(float) const;
+  float (tAnimation<T>::*animFunc)(float) const;
   AnimKeyFrame* currentKeyFrame;
   AnimKeyFrame* nextKeyFrame;
@@ -148,5 +148,5 @@
 */
 template<class T>
-tAnim<T>::tAnim (T* object, void (T::*funcToAnim)(float)) 
+tAnimation<T>::tAnimation (T* object, void (T::*funcToAnim)(float)) 
 {
   // create a new List
@@ -160,5 +160,5 @@
   this->nextKeyFrame = tmpKeyFrame;
 
-  this->animFunc = &tAnim<T>::linear;
+  this->animFunc = &tAnimation<T>::linear;
 
   this->setFuncToAnim(object, funcToAnim);
@@ -171,5 +171,5 @@
 */
 template<class T>
-tAnim<T>::~tAnim () 
+tAnimation<T>::~tAnimation () 
 {
   // delete all the KeyFrames
@@ -187,5 +187,5 @@
 
 template<class T>
-void tAnim<T>::rewind(void)
+void tAnimation<T>::rewind(void)
 {
   this->currentKeyFrame = keyFrameList->firstElement();
@@ -195,5 +195,5 @@
 
 template<class T>
-void tAnim<T>::setFuncToAnim(T* object, void (T::*funcToAnim)(float))
+void tAnimation<T>::setFuncToAnim(T* object, void (T::*funcToAnim)(float))
 {
   this->baseObject = this->object = object;
@@ -202,5 +202,5 @@
 
 template<class T>
-void tAnim<T>::addKeyFrame(float value, float duration, ANIM_FUNCTION animFunc)
+void tAnimation<T>::addKeyFrame(float value, float duration, ANIM_FUNCTION animFunc)
 {
   // some small check
@@ -232,5 +232,5 @@
 
 template<class T>
-void tAnim<T>::tick(float time)
+void tAnimation<T>::tick(float time)
 {
   if (this->bRunning)
@@ -265,5 +265,5 @@
 
 template<class T>
-void tAnim<T>::setAnimFunc(ANIM_FUNCTION animFunc)
+void tAnimation<T>::setAnimFunc(ANIM_FUNCTION animFunc)
 {
   switch (animFunc)
@@ -271,21 +271,21 @@
     default:
     case ANIM_CONSTANT:
-      this->animFunc = &tAnim<T>::constant;
+      this->animFunc = &tAnimation<T>::constant;
       break;
     case ANIM_LINEAR:
-      this->animFunc = &tAnim<T>::linear;
+      this->animFunc = &tAnimation<T>::linear;
       break;
     case ANIM_SINE:
-      this->animFunc = &tAnim<T>::sine;
+      this->animFunc = &tAnimation<T>::sine;
       break;
     case ANIM_COSINE:
-      this->animFunc = &tAnim<T>::cosine;
+      this->animFunc = &tAnimation<T>::cosine;
       break;
     case ANIM_EXP:
-      this->animFunc = &tAnim<T>::exp;
+      this->animFunc = &tAnimation<T>::exp;
       break;
     case ANIM_NEG_EXP:
       {
-	this->animFunc = &tAnim<T>::negExp;
+	this->animFunc = &tAnimation<T>::negExp;
 	float d = fabs(this->currentKeyFrame->value - this->nextKeyFrame->value);
 	expFactor =  - 1.0 / this->currentKeyFrame->duration * logf(DELTA_X);
@@ -293,8 +293,8 @@
       }
     case ANIM_QUADRATIC:
-      this->animFunc = &tAnim<T>::quadratic;
+      this->animFunc = &tAnimation<T>::quadratic;
       break;
     case ANIM_RANDOM:
-      this->animFunc = &tAnim<T>::random;
+      this->animFunc = &tAnimation<T>::random;
       break;
     }
@@ -304,5 +304,5 @@
 // animation functions
 template<class T>
-float tAnim<T>::random(float timePassed) const
+float tAnimation<T>::random(float timePassed) const
 {
   return (float)rand()/(float)RAND_MAX;
@@ -310,5 +310,5 @@
 
 template<class T>
-float tAnim<T>::constant(float timePassed) const
+float tAnimation<T>::constant(float timePassed) const
 {
   return this->currentKeyFrame->value;
@@ -316,5 +316,5 @@
 
 template<class T>
-float tAnim<T>::linear(float timePassed) const 
+float tAnimation<T>::linear(float timePassed) const 
 {
   return this->currentKeyFrame->value + (this->nextKeyFrame->value - this->currentKeyFrame->value) 
@@ -325,5 +325,5 @@
 
 template<class T>
-float tAnim<T>::sine(float timePassed) const
+float tAnimation<T>::sine(float timePassed) const
 {
   float d = this->currentKeyFrame->value - this->nextKeyFrame->value;
@@ -337,5 +337,5 @@
 
 template<class T>
-float tAnim<T>::cosine(float timePassed) const
+float tAnimation<T>::cosine(float timePassed) const
 {
   float d = this->currentKeyFrame->value - this->nextKeyFrame->value;
@@ -350,10 +350,10 @@
 
 template<class T>
-float tAnim<T>::exp(float timePassed) const
-{
-}
-
-template<class T>
-float tAnim<T>::negExp(float timePassed) const
+float tAnimation<T>::exp(float timePassed) const
+{
+}
+
+template<class T>
+float tAnimation<T>::negExp(float timePassed) const
 {
   float d = this->currentKeyFrame->value - this->nextKeyFrame->value;
@@ -363,5 +363,5 @@
 
 template<class T>
-float tAnim<T>::quadratic(float timePassed) const
+float tAnimation<T>::quadratic(float timePassed) const
 {
 
Index: /orxonox/trunk/src/animation_player.cc
===================================================================
--- /orxonox/trunk/src/animation_player.cc	(revision 3846)
+++ /orxonox/trunk/src/animation_player.cc	(revision 3847)
@@ -28,5 +28,5 @@
    this->setClassName ("AnimationPlayer");
 
-   this->animationList = new tList<Anim>();
+   this->animationList = new tList<Animation>();
    this->play();
 }
@@ -72,5 +72,5 @@
    unadding it with animation->notHandled();
 */
-void AnimationPlayer::addAnimation(Anim* animation)
+void AnimationPlayer::addAnimation(Animation* animation)
 {
   this->animationList->add(animation);
@@ -81,5 +81,5 @@
    \param animation the Anmination to remove from the List
 */
-void AnimationPlayer::removeAnimation(Anim* animation)
+void AnimationPlayer::removeAnimation(Animation* animation)
 {
   this->animationList->remove(animation);
@@ -92,6 +92,6 @@
 {
   // deleting the Animation List AND all the elements of the List
-  tIterator<Anim>* animIt = this->animationList->getIterator();
-  Anim* anim = animIt->nextElement();
+  tIterator<Animation>* animIt = this->animationList->getIterator();
+  Animation* anim = animIt->nextElement();
   while( anim != NULL)
     {
@@ -103,5 +103,5 @@
 
   delete this->animationList;
-  this->animationList = new tList<Anim>();
+  this->animationList = new tList<Animation>();
 }
 
@@ -115,6 +115,6 @@
     {
       // iterate through all the animations and tick them.
-      tIterator<Anim>* animIt = this->animationList->getIterator();
-      Anim* anim = animIt->nextElement();
+      tIterator<Animation>* animIt = this->animationList->getIterator();
+      Animation* anim = animIt->nextElement();
       while( anim != NULL)
 	{
@@ -142,8 +142,8 @@
 
 
-Anim* AnimationPlayer::getObjectFromBaseObject(const BaseObject* baseObject) const
+Animation* AnimationPlayer::getObjectFromBaseObject(const BaseObject* baseObject) const
 {
-  tIterator<Anim>* animIt = this->animationList->getIterator();
-  Anim* anim = animIt->nextElement();
+  tIterator<Animation>* animIt = this->animationList->getIterator();
+  Animation* anim = animIt->nextElement();
   while( anim != NULL)
     {
@@ -173,6 +173,6 @@
   PRINT(0)("-Animation Information---------------+\n");
   // Per ANIMATION DEBUG
-  tIterator<Anim>* animIt = this->animationList->getIterator();
-  Anim* anim = animIt->nextElement();
+  tIterator<Animation>* animIt = this->animationList->getIterator();
+  Animation* anim = animIt->nextElement();
   while( anim != NULL)
     {
Index: /orxonox/trunk/src/animation_player.h
===================================================================
--- /orxonox/trunk/src/animation_player.h	(revision 3846)
+++ /orxonox/trunk/src/animation_player.h	(revision 3847)
@@ -33,6 +33,6 @@
 
   // animation handling
-  void addAnimation(Anim* animation);
-  void removeAnimation(Anim* animation);
+  void addAnimation(Animation* animation);
+  void removeAnimation(Animation* animation);
   void flush(void);
 
@@ -42,5 +42,5 @@
   void pause(void);
 
-  Anim* getObjectFromBaseObject(const BaseObject* baseObject) const;
+  Animation* getObjectFromBaseObject(const BaseObject* baseObject) const;
 
   void debug(void);
@@ -52,5 +52,5 @@
 
   /* class specific */
-  tList<Anim>* animationList;              //!< A List of Animations to be handled.
+  tList<Animation>* animationList;         //!< A List of Animations to be handled.
   bool bRunning;                           //!< If the AnimationPlayer is running.
 };
Index: /orxonox/trunk/src/simple_animation.cc
===================================================================
--- /orxonox/trunk/src/simple_animation.cc	(revision 3846)
+++ /orxonox/trunk/src/simple_animation.cc	(revision 3847)
@@ -46,5 +46,5 @@
    this->setClassName ("SimpleAnimation");
    this->frames = new tList<KeyFrame>();
-   this->animators = new tList<Animation>();
+   this->animators = new tList<Animation3D>();
    this->localTime = 0;
    this->bRunning = false;
@@ -119,8 +119,8 @@
 void SimpleAnimation::selectObject(WorldEntity* entity)
 {
-  Animation* anim = getAnimationFromWorldEntity(entity);
+  Animation3D* anim = getAnimationFromWorldEntity(entity);
   if( anim == NULL)
     {
-      anim = new Animation;
+      anim = new Animation3D;
       anim->object = entity;
       anim->lastPosition = new Vector();
@@ -310,6 +310,6 @@
 void SimpleAnimation::tick(float time)
 {
-  tIterator<Animation>* iterator = this->animators->getIterator();
-  Animation* anim = iterator->nextElement();
+  tIterator<Animation3D>* iterator = this->animators->getIterator();
+  Animation3D* anim = iterator->nextElement();
   while( anim != NULL)
     {
@@ -383,8 +383,8 @@
 
 
-Animation* SimpleAnimation::getAnimationFromWorldEntity(WorldEntity* entity)
-{
-  tIterator<Animation>* iterator = this->animators->getIterator();
-  Animation* anim = iterator->nextElement();
+Animation3D* SimpleAnimation::getAnimationFromWorldEntity(WorldEntity* entity)
+{
+  tIterator<Animation3D>* iterator = this->animators->getIterator();
+  Animation3D* anim = iterator->nextElement();
   while( anim != NULL)
     {
Index: /orxonox/trunk/src/simple_animation.h
===================================================================
--- /orxonox/trunk/src/simple_animation.h	(revision 3846)
+++ /orxonox/trunk/src/simple_animation.h	(revision 3847)
@@ -13,4 +13,5 @@
 #include "base_object.h"
 #include "list.h"
+#include "animation_player.h"
 
 
@@ -41,6 +42,7 @@
    This represents an animation for a object
 */
-typedef struct Animation {
-
+class Animation3D
+{
+ public:
   WorldEntity* object;
   Vector* lastPosition;
@@ -64,5 +66,4 @@
 */
 class SimpleAnimation : public BaseObject {
-  
  public:
   static SimpleAnimation* getInstance();
@@ -94,5 +95,5 @@
   bool bRunning;                   //<! is set, when the animation is running
   tList<KeyFrame>* frames;         //<! where keyframes are stored in
-  tList<Animation>* animators;      //<! a list of animation's
+  tList<Animation3D>* animators;      //<! a list of animation's
   KeyFrame* currentFrame;          //<! the frame that is been played now
   KeyFrame* lastFrame;
@@ -104,8 +105,8 @@
   Vector* tmpVect;                 //<! this is the temporary vector save place - 
   WorldEntity* workingObject;      //<! this is a pointer to the current working object that has been selected via selectObject()
-  Animation* workingAnimator;       //<! the animator with which you are currently working
+  Animation3D* workingAnimator;       //<! the animator with which you are currently working
   float deltaT;                    //<! this is a time constant for the movement
 
-  Animation* getAnimationFromWorldEntity(WorldEntity* entity);
+  Animation3D* getAnimationFromWorldEntity(WorldEntity* entity);
 
 };
Index: /orxonox/trunk/src/story_entities/world.h
===================================================================
--- /orxonox/trunk/src/story_entities/world.h	(revision 3846)
+++ /orxonox/trunk/src/story_entities/world.h	(revision 3847)
@@ -99,6 +99,4 @@
   GLMenuImageScreen* glmis;           //!< The Level-Loader Display
 
-  Text* testText;                     //!< A text to Test the TextEngine;
-
   char* worldName;                    //!< The name of this World
   int debugWorldNr;                   //!< The Debug Nr. needed, if something goes wrong
Index: /orxonox/trunk/src/track_manager.cc
===================================================================
--- /orxonox/trunk/src/track_manager.cc	(revision 3846)
+++ /orxonox/trunk/src/track_manager.cc	(revision 3847)
@@ -393,6 +393,6 @@
   this->trackText->setAlignment(TEXT_ALIGN_SCREEN_CENTER);
   // initializing the Animation for the Text.
-  this->textAnimation = new tAnim<Text>(this->trackText, &Text::setBlending);
-  this->textAnimation->addKeyFrame(1.0, 3.0, ANIM_LINEAR);
+  this->textAnimation = new tAnimation<Text>(this->trackText, &Text::setBlending);
+  this->textAnimation->addKeyFrame(1.0, 3.0, ANIM_NEG_EXP);
   this->textAnimation->addKeyFrame(0.0, .001);
   this->textAnimation->setInfinity(ANIM_INF_CONSTANT);
Index: /orxonox/trunk/src/track_manager.h
===================================================================
--- /orxonox/trunk/src/track_manager.h	(revision 3846)
+++ /orxonox/trunk/src/track_manager.h	(revision 3847)
@@ -18,5 +18,5 @@
 class PNode;
 class Text;
-template<class T> class tAnim;
+template<class T> class tAnimation;
 template<class T> class tList;
 
@@ -144,5 +144,5 @@
   PNode* trackNode;                   //!< The main TrackNode of this Track.
   Text* trackText;                    //!< The text to display when switching between Worlds.
-  tAnim<Text>* textAnimation;         //!< An Animation for the Text.
+  tAnimation<Text>* textAnimation;    //!< An Animation for the Text.
   
   void initChildren(unsigned int childCount, TrackElement* trackElem = NULL);
Index: /orxonox/trunk/src/world_entities/test_gun.cc
===================================================================
--- /orxonox/trunk/src/world_entities/test_gun.cc	(revision 3846)
+++ /orxonox/trunk/src/world_entities/test_gun.cc	(revision 3847)
@@ -52,6 +52,8 @@
     this->projOffset = new Vector(1.0, 0.0, 0.5);
 
+
   this->animator = SimpleAnimation::getInstance();
-  this->dummy1 = new WorldEntity(); /* a world entity that is not drawed: use this for the weapon */
+  this->dummy1 = new WorldEntity(); // a world entity that is not drawed: use this for the weapon 
+  /*
   parent->addChild(this->dummy1, PNODE_ALL);
 
@@ -73,5 +75,5 @@
     }
   this->animator->animatorEnd();
-  
+  */
 }
 
@@ -131,8 +133,10 @@
   this->localTime = 0;
   
-  this->animator->animatorBegin();
-  this->animator->selectObject(this->dummy1);
-  this->animator->start();
-  this->animator->animatorEnd();
+  /*
+    this->animator->animatorBegin();
+    this->animator->selectObject(this->dummy1);
+    this->animator->start();
+    this->animator->animatorEnd();
+  */
 }
 